using System;
using System.Collections;
using System.ComponentModel;
using System.Drawing;
using System.Data;
using System.Windows.Forms;
using Zcu.Mve.Core;

namespace Zcu.Gsvd.MeshLS
{
	/// <summary>
	/// Dialog for selecting output file and choosing TRI format parts.
	/// </summary>
	public class MeshSaverSetup : ModuleSetup
	{
		private System.Windows.Forms.TextBox tBoxFilename;
		private System.Windows.Forms.Button butBrowse;
		private System.Windows.Forms.Label label1;
		private System.Windows.Forms.SaveFileDialog saveFileDialog;
		private System.Windows.Forms.CheckBox chbVerticesNormals;
		private System.Windows.Forms.CheckBox chbTriangleNeighbors;
		private System.Windows.Forms.CheckBox chbTriangleNormals;
		private System.Windows.Forms.CheckBox chbTriangles;
		private System.Windows.Forms.Label label2;
		private System.Windows.Forms.Label label3;
		/// <summary> 
		/// Required designer variable.
		/// </summary>
		private System.ComponentModel.Container components = null;

		private MeshSaver meshSaver;

		/// <summary>
		/// Constructor of MeshSaverSetup.
		/// </summary>
		/// <param name="meshSaver">MeshSaver object.</param>
		/// <param name="oldFileName">Name of previous selected file.</param>
		public MeshSaverSetup(MeshSaver meshSaver, string oldFileName)
		{
			// This call is required by the Windows.Forms Form Designer.
			InitializeComponent();

			this.meshSaver = meshSaver;
			this.tBoxFilename.Text = oldFileName;

			this.chbTriangles.Checked         = this.meshSaver.flags[0];
			this.chbTriangleNormals.Checked   = this.meshSaver.flags[1];
			this.chbTriangleNeighbors.Checked = this.meshSaver.flags[2];
			this.chbVerticesNormals.Checked   = this.meshSaver.flags[3];
			                                               // Sets flags for TRI format.

		}

		/// <summary> 
		/// Clean up any resources being used.
		/// </summary>
		protected override void Dispose( bool disposing )
		{
			if( disposing )
			{
				if(components != null)
				{
					components.Dispose();
				}
			}
			base.Dispose( disposing );
		}

		#region Component Designer generated code
		/// <summary> 
		/// Required method for Designer support - do not modify 
		/// the contents of this method with the code editor.
		/// </summary>
		private void InitializeComponent()
		{
			this.tBoxFilename = new System.Windows.Forms.TextBox();
			this.butBrowse = new System.Windows.Forms.Button();
			this.label1 = new System.Windows.Forms.Label();
			this.saveFileDialog = new System.Windows.Forms.SaveFileDialog();
			this.chbVerticesNormals = new System.Windows.Forms.CheckBox();
			this.chbTriangleNeighbors = new System.Windows.Forms.CheckBox();
			this.chbTriangleNormals = new System.Windows.Forms.CheckBox();
			this.chbTriangles = new System.Windows.Forms.CheckBox();
			this.label2 = new System.Windows.Forms.Label();
			this.label3 = new System.Windows.Forms.Label();
			this.SuspendLayout();
			// 
			// tBoxFilename
			// 
			this.tBoxFilename.Location = new System.Drawing.Point(24, 24);
			this.tBoxFilename.Name = "tBoxFilename";
			this.tBoxFilename.Size = new System.Drawing.Size(232, 20);
			this.tBoxFilename.TabIndex = 0;
			this.tBoxFilename.Text = "";
			// 
			// butBrowse
			// 
			this.butBrowse.Location = new System.Drawing.Point(256, 24);
			this.butBrowse.Name = "butBrowse";
			this.butBrowse.Size = new System.Drawing.Size(24, 20);
			this.butBrowse.TabIndex = 1;
			this.butBrowse.Text = "...";
			this.butBrowse.Click += new System.EventHandler(this.butBrowse_Click);
			// 
			// label1
			// 
			this.label1.Location = new System.Drawing.Point(8, 8);
			this.label1.Name = "label1";
			this.label1.Size = new System.Drawing.Size(100, 16);
			this.label1.TabIndex = 2;
			this.label1.Text = "Selected file";
			// 
			// chbVerticesNormals
			// 
			this.chbVerticesNormals.Checked = true;
			this.chbVerticesNormals.CheckState = System.Windows.Forms.CheckState.Checked;
			this.chbVerticesNormals.Location = new System.Drawing.Point(24, 160);
			this.chbVerticesNormals.Name = "chbVerticesNormals";
			this.chbVerticesNormals.Size = new System.Drawing.Size(128, 24);
			this.chbVerticesNormals.TabIndex = 9;
			this.chbVerticesNormals.Text = "Vertices\' Normals";
			// 
			// chbTriangleNeighbors
			// 
			this.chbTriangleNeighbors.Checked = true;
			this.chbTriangleNeighbors.CheckState = System.Windows.Forms.CheckState.Checked;
			this.chbTriangleNeighbors.Location = new System.Drawing.Point(24, 136);
			this.chbTriangleNeighbors.Name = "chbTriangleNeighbors";
			this.chbTriangleNeighbors.Size = new System.Drawing.Size(128, 24);
			this.chbTriangleNeighbors.TabIndex = 8;
			this.chbTriangleNeighbors.Text = "Triangles\' Neighbors";
			// 
			// chbTriangleNormals
			// 
			this.chbTriangleNormals.Checked = true;
			this.chbTriangleNormals.CheckState = System.Windows.Forms.CheckState.Checked;
			this.chbTriangleNormals.Location = new System.Drawing.Point(24, 112);
			this.chbTriangleNormals.Name = "chbTriangleNormals";
			this.chbTriangleNormals.Size = new System.Drawing.Size(128, 24);
			this.chbTriangleNormals.TabIndex = 7;
			this.chbTriangleNormals.Text = "Triangles\' Normals";
			// 
			// chbTriangles
			// 
			this.chbTriangles.Checked = true;
			this.chbTriangles.CheckState = System.Windows.Forms.CheckState.Checked;
			this.chbTriangles.Location = new System.Drawing.Point(24, 88);
			this.chbTriangles.Name = "chbTriangles";
			this.chbTriangles.TabIndex = 6;
			this.chbTriangles.Text = "Triangles";
			// 
			// label2
			// 
			this.label2.Location = new System.Drawing.Point(24, 192);
			this.label2.Name = "label2";
			this.label2.Size = new System.Drawing.Size(256, 23);
			this.label2.TabIndex = 5;
			this.label2.Text = "Checked attributes will be saved (if exist in mesh).";
			// 
			// label3
			// 
			this.label3.Location = new System.Drawing.Point(8, 72);
			this.label3.Name = "label3";
			this.label3.Size = new System.Drawing.Size(232, 16);
			this.label3.TabIndex = 10;
			this.label3.Text = "Select attributes to save (only for TRI format)";
			// 
			// MeshSaverSetup
			// 
			this.Controls.Add(this.label3);
			this.Controls.Add(this.chbVerticesNormals);
			this.Controls.Add(this.chbTriangleNeighbors);
			this.Controls.Add(this.chbTriangleNormals);
			this.Controls.Add(this.chbTriangles);
			this.Controls.Add(this.label2);
			this.Controls.Add(this.label1);
			this.Controls.Add(this.butBrowse);
			this.Controls.Add(this.tBoxFilename);
			this.Name = "MeshSaverSetup";
			this.Size = new System.Drawing.Size(288, 216);
			this.ResumeLayout(false);

		}
		#endregion

		/// <summary>
		/// Analyze type of selected file based on file extension.
		/// </summary>
		/// <param name="path">Full filename (full path and filename).</param>
		/// <returns>Type of selected input file - 1 - TRI format,
		///                                        2 - STL,
		///                                        3 - PLY,
		///                                        0 - unknown format.</returns>
		private byte tellFileType(string path)
		{
			if (path.EndsWith(".tri")) 
			{
				return 1;
			}
			else if (path.EndsWith(".stl")) 
			{
				return 2;
			}
			else if (path.EndsWith(".ply")) 
			{
				return 3;
			}
			else
			{
				return 0;
			}
		}

		/// <summary>
		/// Handler for browse button click.
		/// </summary>
		private void butBrowse_Click(object sender, System.EventArgs e)
		{
			this.saveFileDialog = new SaveFileDialog();
			this.saveFileDialog.Filter = "TRI files|*.tri|STL files|*.stl|PLY files|*.ply";
			this.saveFileDialog.ShowDialog();
			
			if (this.saveFileDialog.FileName != "") 
			{
				this.tBoxFilename.Text = this.saveFileDialog.FileName;
			}
			this.saveFileDialog.Dispose();
		}

		/// <summary>
		/// Handler for OK button click - store input file name and tests filename. 
		/// </summary>
		/// <returns>Returns True if selected file is supported.</returns>
		public override bool OnOkClick()
		{
			this.meshSaver.nameOfFile = this.tBoxFilename.Text;

			this.meshSaver.flags[0] = this.chbTriangles.Checked;
			this.meshSaver.flags[1] = this.chbTriangleNormals.Checked;
			this.meshSaver.flags[2] = this.chbTriangleNeighbors.Checked;
			this.meshSaver.flags[3] = this.chbVerticesNormals.Checked;

			if ((this.meshSaver.typeOfFile = this.tellFileType(this.tBoxFilename.Text)) == 0)
			{
				MessageBox.Show(this, "Unknown file format!\n\nSee help for list of supported file types.", "Error", MessageBoxButtons.OK, MessageBoxIcon.Error);
				return false;
			}
			else
			{
				return true;
			}
		}
	}
}
